import { Component, ElementRef, Input, ViewChild, NgModule, EventEmitter, Output, HostBinding } from '@angular/core';
import { CommonModule } from '@angular/common';
import { __extends, __assign } from 'tslib';
import { AlluvialChart, AreaChart, StackedAreaChart, SimpleBarChart, GroupedBarChart, StackedBarChart, BoxplotChart, BubbleChart, BulletChart, DonutChart, GaugeChart, HistogramChart, LineChart, LollipopChart, PieChart, ScatterChart, MeterChart, RadarChart, ComboChart, TreeChart, TreemapChart, CirclePackChart, WordCloudChart, HeatmapChart, EXPERIMENTAL_ChoroplethChart } from '@carbon/charts';
import { buildStraightPathString } from '@carbon/charts/components/diagrams/buildPaths';
import { arrowLeft, arrowRight, circle, diamond, square, tee } from '@carbon/charts/components/diagrams/markerDefinitions';

/**
 * @fileoverview added by tsickle
 * Generated from: base-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `BaseChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var BaseChart = /** @class */ (function () {
    function BaseChart(elementRef) {
        this.elementRef = elementRef;
    }
    Object.defineProperty(BaseChart.prototype, "data", {
        get: /**
         * @return {?}
         */
        function () {
            return this._data;
        },
        /**
         * Data passed to charts library for displaying
         */
        set: /**
         * Data passed to charts library for displaying
         * @param {?} newData
         * @return {?}
         */
        function (newData) {
            // If data already exists, that means the chart has been initialized
            /** @type {?} */
            var dataExistsAlready = this._data !== null && this._data !== undefined;
            this._data = newData;
            if (dataExistsAlready) {
                this.chart.model.setData(newData);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseChart.prototype, "options", {
        get: /**
         * @return {?}
         */
        function () {
            return this._options;
        },
        /**
         * Options passed to charts library
         */
        set: /**
         * Options passed to charts library
         * @param {?} newOptions
         * @return {?}
         */
        function (newOptions) {
            // If data already exists, that means the chart has been initialized
            /** @type {?} */
            var optionsExistAlready = this._options !== null && this._options !== undefined;
            this._options = newOptions;
            if (optionsExistAlready) {
                this.chart.model.setOptions(newOptions);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BaseChart.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        // Width prop is mandatory for the wrappers
        if (this.width) {
            this.options.width = this.width;
        }
        // Height prop is mandatory for the wrappers
        if (this.height) {
            this.options.height = this.height;
        }
    };
    /**
     * Runs after view init to create a chart, attach it to `chartRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `chartRef` and draw it.
     * @return {?}
     */
    BaseChart.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `chartRef` and draw it.
     * @return {?}
     */
    function () {
        console.log("You need to implement your own `ngAfterViewInit()` function");
    };
    BaseChart.decorators = [
        { type: Component, args: [{
                    selector: "ibm-base-chart",
                    template: ""
                }] }
    ];
    /** @nocollapse */
    BaseChart.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    BaseChart.propDecorators = {
        data: [{ type: Input }],
        options: [{ type: Input }],
        width: [{ type: Input }],
        height: [{ type: Input }],
        chartRef: [{ type: ViewChild, args: ["nChart",] }]
    };
    return BaseChart;
}());
if (false) {
    /**
     * Chart width
     * @type {?}
     */
    BaseChart.prototype.width;
    /**
     * Chart height
     * @type {?}
     */
    BaseChart.prototype.height;
    /**
     * Chart container element ref
     * @type {?}
     */
    BaseChart.prototype.chartRef;
    /**
     * Chart object instance
     *
     * You can use this to do whatever you would normally do with a chart if you used
     * charts library directly.
     * @type {?}
     */
    BaseChart.prototype.chart;
    /**
     * @type {?}
     * @private
     */
    BaseChart.prototype._data;
    /**
     * @type {?}
     * @private
     */
    BaseChart.prototype._options;
    /**
     * @type {?}
     * @protected
     */
    BaseChart.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: alluvial-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `Alluvial` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var AlluvialChartComponent = /** @class */ (function (_super) {
    __extends(AlluvialChartComponent, _super);
    function AlluvialChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    AlluvialChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new AlluvialChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    AlluvialChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-alluvial-chart",
                    template: ""
                }] }
    ];
    return AlluvialChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: area-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `AreaChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var AreaChartComponent = /** @class */ (function (_super) {
    __extends(AreaChartComponent, _super);
    function AreaChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `chartRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `chartRef` and draw it.
     * @return {?}
     */
    AreaChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `chartRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new AreaChart(this.chartRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    AreaChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-area-chart",
                    template: "\n\t\t<div #nChart class=\"ibm-chart-container\">\n\t\t</div>\n\t"
                }] }
    ];
    return AreaChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: area-chart-stacked.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `StackedAreaChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var StackedAreaChartComponent = /** @class */ (function (_super) {
    __extends(StackedAreaChartComponent, _super);
    function StackedAreaChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    StackedAreaChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new StackedAreaChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    StackedAreaChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-stacked-area-chart",
                    template: ""
                }] }
    ];
    return StackedAreaChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: bar-chart-simple.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `SimpleBarChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var SimpleBarChartComponent = /** @class */ (function (_super) {
    __extends(SimpleBarChartComponent, _super);
    function SimpleBarChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    SimpleBarChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new SimpleBarChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    SimpleBarChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-simple-bar-chart",
                    template: ""
                }] }
    ];
    return SimpleBarChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: bar-chart-grouped.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `GroupedBarChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var GroupedBarChartComponent = /** @class */ (function (_super) {
    __extends(GroupedBarChartComponent, _super);
    function GroupedBarChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    GroupedBarChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new GroupedBarChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    GroupedBarChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-grouped-bar-chart",
                    template: ""
                }] }
    ];
    return GroupedBarChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: bar-chart-stacked.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `StackedBarChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var StackedBarChartComponent = /** @class */ (function (_super) {
    __extends(StackedBarChartComponent, _super);
    function StackedBarChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    StackedBarChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new StackedBarChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    StackedBarChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-stacked-bar-chart",
                    template: ""
                }] }
    ];
    return StackedBarChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: boxplot-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `BoxplotChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var BoxplotChartComponent = /** @class */ (function (_super) {
    __extends(BoxplotChartComponent, _super);
    function BoxplotChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    BoxplotChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new BoxplotChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    BoxplotChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-boxplot-chart",
                    template: ""
                }] }
    ];
    return BoxplotChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: bubble-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `BubbleChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var BubbleChartComponent = /** @class */ (function (_super) {
    __extends(BubbleChartComponent, _super);
    function BubbleChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    BubbleChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new BubbleChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    BubbleChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-bubble-chart",
                    template: ""
                }] }
    ];
    return BubbleChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: bullet-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `BulletChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var BulletChartComponent = /** @class */ (function (_super) {
    __extends(BulletChartComponent, _super);
    function BulletChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    BulletChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new BulletChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    BulletChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-bullet-chart",
                    template: ""
                }] }
    ];
    return BulletChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: donut-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `DonutChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var DonutChartComponent = /** @class */ (function (_super) {
    __extends(DonutChartComponent, _super);
    function DonutChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    DonutChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new DonutChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    DonutChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-donut-chart",
                    template: ""
                }] }
    ];
    return DonutChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: gauge-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `GaugeChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var GaugeChartComponent = /** @class */ (function (_super) {
    __extends(GaugeChartComponent, _super);
    function GaugeChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    GaugeChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new GaugeChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    GaugeChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-gauge-chart",
                    template: ""
                }] }
    ];
    return GaugeChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: histogram-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `HistogramChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var HistogramChartComponent = /** @class */ (function (_super) {
    __extends(HistogramChartComponent, _super);
    function HistogramChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    HistogramChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new HistogramChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    HistogramChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-histogram-chart",
                    template: ""
                }] }
    ];
    return HistogramChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: line-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `LineChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var LineChartComponent = /** @class */ (function (_super) {
    __extends(LineChartComponent, _super);
    function LineChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    LineChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new LineChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    LineChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-line-chart",
                    template: ""
                }] }
    ];
    return LineChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: lollipop-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `LollipopChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var LollipopChartComponent = /** @class */ (function (_super) {
    __extends(LollipopChartComponent, _super);
    function LollipopChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    LollipopChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new LollipopChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    LollipopChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-lollipop-chart",
                    template: ""
                }] }
    ];
    return LollipopChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: pie-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `PieChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var PieChartComponent = /** @class */ (function (_super) {
    __extends(PieChartComponent, _super);
    function PieChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    PieChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new PieChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    PieChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-pie-chart",
                    template: ""
                }] }
    ];
    return PieChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: scatter-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `ScatterChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var ScatterChartComponent = /** @class */ (function (_super) {
    __extends(ScatterChartComponent, _super);
    function ScatterChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    ScatterChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new ScatterChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    ScatterChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-scatter-chart",
                    template: ""
                }] }
    ];
    return ScatterChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: meter-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `MeterChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var MeterChartComponent = /** @class */ (function (_super) {
    __extends(MeterChartComponent, _super);
    function MeterChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    MeterChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new MeterChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    MeterChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-meter-chart",
                    template: ""
                }] }
    ];
    return MeterChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: radar-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `RadarChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var RadarChartComponent = /** @class */ (function (_super) {
    __extends(RadarChartComponent, _super);
    function RadarChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    RadarChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new RadarChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    RadarChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-radar-chart",
                    template: ""
                }] }
    ];
    return RadarChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: combo-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `ComboChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var ComboChartComponent = /** @class */ (function (_super) {
    __extends(ComboChartComponent, _super);
    function ComboChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    ComboChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new ComboChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    ComboChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-combo-chart",
                    template: ""
                }] }
    ];
    return ComboChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: tree-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `TreeChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var TreeChartComponent = /** @class */ (function (_super) {
    __extends(TreeChartComponent, _super);
    function TreeChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    TreeChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new TreeChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    TreeChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-tree-chart",
                    template: ""
                }] }
    ];
    return TreeChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: treemap-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `TreemapChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var TreemapChartComponent = /** @class */ (function (_super) {
    __extends(TreemapChartComponent, _super);
    function TreemapChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    TreemapChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new TreemapChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    TreemapChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-treemap-chart",
                    template: ""
                }] }
    ];
    return TreemapChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: circle-pack-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `BubbleChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var CirclePackChartComponent = /** @class */ (function (_super) {
    __extends(CirclePackChartComponent, _super);
    function CirclePackChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    CirclePackChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new CirclePackChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    CirclePackChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-circle-pack-chart",
                    template: ""
                }] }
    ];
    return CirclePackChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: wordcloud-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `WordCloudChart` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var WordCloudChartComponent = /** @class */ (function (_super) {
    __extends(WordCloudChartComponent, _super);
    function WordCloudChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    WordCloudChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new WordCloudChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    WordCloudChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-wordcloud-chart",
                    template: ""
                }] }
    ];
    return WordCloudChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: heatmap-chart.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `Heatmap` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var HeatmapChartComponent = /** @class */ (function (_super) {
    __extends(HeatmapChartComponent, _super);
    function HeatmapChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    HeatmapChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new HeatmapChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    HeatmapChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-heatmap-chart",
                    template: ""
                }] }
    ];
    return HeatmapChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: choropleth.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Wrapper around `Choropleth` in carbon charts library
 *
 * Most functions just call their equivalent from the chart library.
 */
var EXPERIMENTAL_ChoroplethChartComponent = /** @class */ (function (_super) {
    __extends(EXPERIMENTAL_ChoroplethChartComponent, _super);
    function EXPERIMENTAL_ChoroplethChartComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     */
    /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    EXPERIMENTAL_ChoroplethChartComponent.prototype.ngAfterViewInit = /**
     * Runs after view init to create a chart, attach it to `elementRef` and draw it.
     * @return {?}
     */
    function () {
        this.chart = new EXPERIMENTAL_ChoroplethChart(this.elementRef.nativeElement, {
            data: this.data,
            options: this.options
        });
        Object.assign(this, this.chart);
    };
    EXPERIMENTAL_ChoroplethChartComponent.decorators = [
        { type: Component, args: [{
                    selector: "EXPERIMENTAL-ibm-choropleth-chart",
                    template: ""
                }] }
    ];
    return EXPERIMENTAL_ChoroplethChartComponent;
}(BaseChart));

/**
 * @fileoverview added by tsickle
 * Generated from: charts.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChartsModule = /** @class */ (function () {
    function ChartsModule() {
    }
    ChartsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [
                        BaseChart,
                        AlluvialChartComponent,
                        AreaChartComponent,
                        EXPERIMENTAL_ChoroplethChartComponent,
                        StackedAreaChartComponent,
                        SimpleBarChartComponent,
                        GroupedBarChartComponent,
                        StackedBarChartComponent,
                        BoxplotChartComponent,
                        BubbleChartComponent,
                        BulletChartComponent,
                        DonutChartComponent,
                        GaugeChartComponent,
                        HeatmapChartComponent,
                        HistogramChartComponent,
                        LineChartComponent,
                        LollipopChartComponent,
                        PieChartComponent,
                        ScatterChartComponent,
                        MeterChartComponent,
                        RadarChartComponent,
                        ComboChartComponent,
                        TreeChartComponent,
                        TreemapChartComponent,
                        CirclePackChartComponent,
                        WordCloudChartComponent,
                    ],
                    exports: [
                        BaseChart,
                        AlluvialChartComponent,
                        AreaChartComponent,
                        EXPERIMENTAL_ChoroplethChartComponent,
                        StackedAreaChartComponent,
                        SimpleBarChartComponent,
                        GroupedBarChartComponent,
                        StackedBarChartComponent,
                        BoxplotChartComponent,
                        BubbleChartComponent,
                        BulletChartComponent,
                        DonutChartComponent,
                        GaugeChartComponent,
                        HeatmapChartComponent,
                        HistogramChartComponent,
                        LineChartComponent,
                        LollipopChartComponent,
                        PieChartComponent,
                        ScatterChartComponent,
                        MeterChartComponent,
                        RadarChartComponent,
                        ComboChartComponent,
                        TreeChartComponent,
                        TreemapChartComponent,
                        CirclePackChartComponent,
                        WordCloudChartComponent
                    ],
                },] }
    ];
    return ChartsModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/configs.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var carbonPrefix = 'cds';

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/card-node/card-node.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardNodeComponent = /** @class */ (function () {
    function CardNodeComponent() {
        this.as = 'div';
        this.href = null;
        this.position = 'static';
        this.click = new EventEmitter();
        this.mouseEnter = new EventEmitter();
        this.mouseOver = new EventEmitter();
        this.mouseOut = new EventEmitter();
        this.mouseLeave = new EventEmitter();
        this.mouseMove = new EventEmitter();
        this.namespace = carbonPrefix + "--cc--card-node";
        this.component = 'div';
    }
    /**
     * @return {?}
     */
    CardNodeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.href) {
            this.component = 'a';
        }
        else {
            this.component = this.as;
        }
    };
    CardNodeComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ibm-diagram-card-node',
                    template: "\n\t\t<ng-container [ngSwitch]=\"component\">\n\t\t\t<xhtml:div\n\t\t\t\t*ngSwitchCase=\"'div'\"\n\t\t\t\t[ngClass]=\"[\n\t\t\t\t\tnamespace,\n\t\t\t\t\tstacked ? namespace + '--stacked' : '',\n\t\t\t\t\tnamespace + '--' + component\n\t\t\t\t]\"\n\t\t\t\t[ngStyle]=\"{\n\t\t\t\t\t'border-color': color,\n\t\t\t\t\tposition: position\n\t\t\t\t}\"\n\t\t\t\t(mouseenter)=\"mouseEnter.emit($event)\"\n\t\t\t\t(mouseover)=\"mouseOver.emit($event)\"\n\t\t\t\t(mouseout)=\"mouseOut.emit($event)\"\n\t\t\t\t(mouseleave)=\"mouseLeave.emit($event)\"\n\t\t\t\t(mousemove)=\"mouseMove.emit($event)\"\n\t\t\t\ttabindex=\"0\"\n\t\t\t>\n\t\t\t\t<ng-container *ngTemplateOutlet=\"nodeTemplate\"></ng-container>\n\t\t\t</xhtml:div>\n\n\t\t\t<xhtml:button\n\t\t\t\t*ngSwitchCase=\"'button'\"\n\t\t\t\t[ngClass]=\"[\n\t\t\t\t\tnamespace,\n\t\t\t\t\tstacked ? namespace + '--stacked' : '',\n\t\t\t\t\tnamespace + '--' + component\n\t\t\t\t]\"\n\t\t\t\t[ngStyle]=\"{\n\t\t\t\t\t'border-color': color,\n\t\t\t\t\tposition: position\n\t\t\t\t}\"\n\t\t\t\t(click)=\"click.emit($event)\"\n\t\t\t\t(mouseenter)=\"mouseEnter.emit($event)\"\n\t\t\t\t(mouseover)=\"mouseOver.emit($event)\"\n\t\t\t\t(mouseout)=\"mouseOut.emit($event)\"\n\t\t\t\t(mouseleave)=\"mouseLeave.emit($event)\"\n\t\t\t\t(mousemove)=\"mouseMove.emit($event)\"\n\t\t\t\ttabindex=\"0\"\n\t\t\t>\n\t\t\t\t<ng-container *ngTemplateOutlet=\"nodeTemplate\"></ng-container>\n\t\t\t</xhtml:button>\n\n\t\t\t<xhtml:a\n\t\t\t\t*ngSwitchCase=\"'a'\"\n\t\t\t\t[ngClass]=\"[\n\t\t\t\t\tnamespace,\n\t\t\t\t\tstacked ? namespace + '--stacked' : '',\n\t\t\t\t\tnamespace + '--' + component\n\t\t\t\t]\"\n\t\t\t\t[attr.href]=\"href\"\n\t\t\t\t[ngStyle]=\"{ 'border-color': color, position: position }\"\n\t\t\t\t(mouseenter)=\"mouseEnter.emit($event)\"\n\t\t\t\t(mouseover)=\"mouseOver.emit($event)\"\n\t\t\t\t(mouseout)=\"mouseOut.emit($event)\"\n\t\t\t\t(mouseleave)=\"mouseLeave.emit($event)\"\n\t\t\t\t(mousemove)=\"mouseMove.emit($event)\"\n\t\t\t\ttabindex=\"0\"\n\t\t\t>\n\t\t\t\t<ng-container *ngTemplateOutlet=\"nodeTemplate\"></ng-container>\n\t\t\t</xhtml:a>\n\t\t</ng-container>\n\t\t<ng-template #nodeTemplate>\n\t\t\t<ng-content></ng-content>\n\t\t</ng-template>\n\t"
                }] }
    ];
    CardNodeComponent.propDecorators = {
        as: [{ type: Input }],
        href: [{ type: Input }],
        color: [{ type: Input }],
        stacked: [{ type: Input }],
        position: [{ type: Input }],
        click: [{ type: Output }],
        mouseEnter: [{ type: Output }],
        mouseOver: [{ type: Output }],
        mouseOut: [{ type: Output }],
        mouseLeave: [{ type: Output }],
        mouseMove: [{ type: Output }]
    };
    return CardNodeComponent;
}());
if (false) {
    /** @type {?} */
    CardNodeComponent.prototype.as;
    /** @type {?} */
    CardNodeComponent.prototype.href;
    /** @type {?} */
    CardNodeComponent.prototype.color;
    /** @type {?} */
    CardNodeComponent.prototype.stacked;
    /** @type {?} */
    CardNodeComponent.prototype.position;
    /** @type {?} */
    CardNodeComponent.prototype.click;
    /** @type {?} */
    CardNodeComponent.prototype.mouseEnter;
    /** @type {?} */
    CardNodeComponent.prototype.mouseOver;
    /** @type {?} */
    CardNodeComponent.prototype.mouseOut;
    /** @type {?} */
    CardNodeComponent.prototype.mouseLeave;
    /** @type {?} */
    CardNodeComponent.prototype.mouseMove;
    /** @type {?} */
    CardNodeComponent.prototype.namespace;
    /** @type {?} */
    CardNodeComponent.prototype.component;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/card-node/card-node-column.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardNodeColumnComponent = /** @class */ (function () {
    function CardNodeColumnComponent() {
        this.farsideColumn = false;
    }
    Object.defineProperty(CardNodeColumnComponent.prototype, "class", {
        get: /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var farsideClassName = this.farsideColumn
                ? carbonPrefix + "--cc--card-node__column--farside"
                : '';
            return carbonPrefix + "--cc--card-node__column " + farsideClassName;
        },
        enumerable: true,
        configurable: true
    });
    CardNodeColumnComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ibm-diagram-card-node-column',
                    template: "\n\t\t<xhtml:div>\n\t\t\t<ng-content></ng-content>\n\t\t</xhtml:div>\n\t"
                }] }
    ];
    CardNodeColumnComponent.propDecorators = {
        farsideColumn: [{ type: Input }],
        class: [{ type: HostBinding, args: ['class',] }]
    };
    return CardNodeColumnComponent;
}());
if (false) {
    /** @type {?} */
    CardNodeColumnComponent.prototype.farsideColumn;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/card-node/card-node-label.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardNodeLabelComponent = /** @class */ (function () {
    function CardNodeLabelComponent() {
        this.namespace = carbonPrefix + "--cc--card-node__label";
    }
    CardNodeLabelComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-diagram-card-node-label",
                    template: "\n\t<xhtml:label [ngClass]=\"namespace\">\n\t\t<ng-content></ng-content>\n\t</xhtml:label>\n\t"
                }] }
    ];
    return CardNodeLabelComponent;
}());
if (false) {
    /** @type {?} */
    CardNodeLabelComponent.prototype.namespace;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/card-node/card-node-subtitle.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardNodeSubtitleComponent = /** @class */ (function () {
    function CardNodeSubtitleComponent() {
        this.namespace = carbonPrefix + "--cc--card-node__subtitle";
    }
    CardNodeSubtitleComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-diagram-card-node-subtitle",
                    template: "\n\t<xhtml:div [ngClass]=\"namespace\">\n\t\t<ng-content></ng-content>\n\t</xhtml:div>\n\t"
                }] }
    ];
    return CardNodeSubtitleComponent;
}());
if (false) {
    /** @type {?} */
    CardNodeSubtitleComponent.prototype.namespace;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/card-node/card-node-title.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardNodeTitleComponent = /** @class */ (function () {
    function CardNodeTitleComponent() {
        this.namespace = carbonPrefix + "--cc--card-node__title";
    }
    CardNodeTitleComponent.decorators = [
        { type: Component, args: [{
                    selector: "ibm-diagram-card-node-title",
                    template: "\n\t<xhtml:div [ngClass]=\"namespace\">\n\t\t<ng-content></ng-content>\n\t</xhtml:div>\n\t"
                }] }
    ];
    return CardNodeTitleComponent;
}());
if (false) {
    /** @type {?} */
    CardNodeTitleComponent.prototype.namespace;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/card-node/card-node.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardNodeModule = /** @class */ (function () {
    function CardNodeModule() {
    }
    CardNodeModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [CardNodeComponent, CardNodeColumnComponent, CardNodeLabelComponent, CardNodeSubtitleComponent, CardNodeTitleComponent],
                    exports: [CardNodeComponent, CardNodeColumnComponent, CardNodeLabelComponent, CardNodeSubtitleComponent, CardNodeTitleComponent],
                    imports: [CommonModule]
                },] }
    ];
    return CardNodeModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/edge/edge.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function Coordinates() { }
if (false) {
    /** @type {?} */
    Coordinates.prototype.x;
    /** @type {?} */
    Coordinates.prototype.y;
}
var EdgeComponent = /** @class */ (function () {
    function EdgeComponent() {
        this.namespace = carbonPrefix + "--cc--edge";
        this.straight = buildStraightPathString;
    }
    EdgeComponent.decorators = [
        { type: Component, args: [{
                    selector: "[ibm-graph-edge]",
                    template: "\n\t<svg:g [ngClass]=\"[namespace, variant ? namespace + '--' + variant : '']\">\n\t\t<svg:path\n\t\t\t[ngClass]=\"namespace + '__container'\"\n\t\t\t[attr.d]=\"path ? path : straight(source, target)\"\n\t\t/>\n\t\t<svg:path\n\t\t\t[ngClass]=\"namespace + '__outer'\"\n\t\t\t[attr.d]=\"path ? path : straight(source, target)\"\n\t\t/>\n\t\t<svg:path\n\t\t\t[ngClass]=\"namespace + '__inner'\"\n\t\t\t[attr.d]=\"path ? path : straight(source, target)\"\n\t\t\t[ngStyle]=\"{'stroke': color}\"\n\t\t\t[attr.marker-start]=\"markerStart ? 'url(#' + markerStart + ')' : ''\"\n\t\t\t[attr.marker-end]=\"markerEnd ? 'url(#' + markerEnd + ')' : ''\"\n\t\t/>\n\t</svg:g>\n\t"
                }] }
    ];
    EdgeComponent.propDecorators = {
        color: [{ type: Input }],
        markerEnd: [{ type: Input }],
        markerStart: [{ type: Input }],
        source: [{ type: Input }],
        target: [{ type: Input }],
        variant: [{ type: Input }],
        path: [{ type: Input }]
    };
    return EdgeComponent;
}());
if (false) {
    /** @type {?} */
    EdgeComponent.prototype.color;
    /** @type {?} */
    EdgeComponent.prototype.markerEnd;
    /** @type {?} */
    EdgeComponent.prototype.markerStart;
    /** @type {?} */
    EdgeComponent.prototype.source;
    /** @type {?} */
    EdgeComponent.prototype.target;
    /** @type {?} */
    EdgeComponent.prototype.variant;
    /** @type {?} */
    EdgeComponent.prototype.path;
    /** @type {?} */
    EdgeComponent.prototype.pathClasses;
    /** @type {?} */
    EdgeComponent.prototype.namespace;
    /** @type {?} */
    EdgeComponent.prototype.straight;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/edge/edge.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EdgeModule = /** @class */ (function () {
    function EdgeModule() {
    }
    EdgeModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [EdgeComponent],
                    exports: [EdgeComponent],
                    imports: [CommonModule]
                },] }
    ];
    return EdgeModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/marker/marker.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var template = "\n<svg:marker\n\t[ngClass]=\"namespace\"\n\t[attr.markerHeight]=\"height\"\n\t[attr.markerWidth]=\"width\"\n\t[attr.orient]=\"orient\"\n\t[attr.id]=\"id\"\n\t[attr.refX]=\"refX\"\n\t[attr.refY]=\"refY\"\n\tmarkerUnits=\"userSpaceOnUse\">\n\t<svg:path [attr.d]=\"d\" [ngStyle]=\"{'fill': color}\" ></svg:path>\n</svg:marker>\n";
var MarkerComponent = /** @class */ (function () {
    function MarkerComponent() {
        var _this = this;
        this.orient = "auto";
        this.position = "end";
        this.namespace = carbonPrefix + "--cc--marker";
        this.setAttributes = (/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var d = _a.d, id = _a.id, height = _a.height, width = _a.width;
            /** @type {?} */
            var xPos = (_this.position === "end") ? (width / 2) + 0.5 : 0.5;
            /** @type {?} */
            var yPos = height / 2;
            _this.d = _this.d || d;
            _this.id = _this.id || id;
            _this.height = _this.height || height;
            _this.width = _this.width || width;
            _this.refX = _this.refX || xPos;
            _this.refY = _this.refY || yPos;
        });
    }
    MarkerComponent.decorators = [
        { type: Component, args: [{
                    selector: "[ibm-graph-marker]",
                    template: template
                }] }
    ];
    MarkerComponent.propDecorators = {
        d: [{ type: Input }],
        color: [{ type: Input }],
        id: [{ type: Input }],
        orient: [{ type: Input }],
        height: [{ type: Input }],
        width: [{ type: Input }],
        refX: [{ type: Input }],
        refY: [{ type: Input }],
        position: [{ type: Input }]
    };
    return MarkerComponent;
}());
if (false) {
    /** @type {?} */
    MarkerComponent.prototype.d;
    /** @type {?} */
    MarkerComponent.prototype.color;
    /** @type {?} */
    MarkerComponent.prototype.id;
    /** @type {?} */
    MarkerComponent.prototype.orient;
    /** @type {?} */
    MarkerComponent.prototype.height;
    /** @type {?} */
    MarkerComponent.prototype.width;
    /** @type {?} */
    MarkerComponent.prototype.refX;
    /** @type {?} */
    MarkerComponent.prototype.refY;
    /** @type {?} */
    MarkerComponent.prototype.position;
    /** @type {?} */
    MarkerComponent.prototype.namespace;
    /** @type {?} */
    MarkerComponent.prototype.setAttributes;
}
var MarkerArrowLeftComponent = /** @class */ (function (_super) {
    __extends(MarkerArrowLeftComponent, _super);
    function MarkerArrowLeftComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    MarkerArrowLeftComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { this.setAttributes(__assign({}, arrowLeft)); };
    MarkerArrowLeftComponent.decorators = [
        { type: Component, args: [{ selector: "[ibm-graph-marker-arrow-left]", template: template }] }
    ];
    return MarkerArrowLeftComponent;
}(MarkerComponent));
var MarkerArrowRightComponent = /** @class */ (function (_super) {
    __extends(MarkerArrowRightComponent, _super);
    function MarkerArrowRightComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    MarkerArrowRightComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { this.setAttributes(__assign({}, arrowRight)); };
    MarkerArrowRightComponent.decorators = [
        { type: Component, args: [{ selector: "[ibm-graph-marker-arrow-right]", template: template }] }
    ];
    return MarkerArrowRightComponent;
}(MarkerComponent));
var MarkerShapeNodeComponent = /** @class */ (function (_super) {
    __extends(MarkerShapeNodeComponent, _super);
    function MarkerShapeNodeComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    MarkerShapeNodeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { this.setAttributes(__assign({}, circle)); };
    MarkerShapeNodeComponent.decorators = [
        { type: Component, args: [{ selector: "[ibm-graph-marker-circle]", template: template }] }
    ];
    return MarkerShapeNodeComponent;
}(MarkerComponent));
var MarkerDiamondComponent = /** @class */ (function (_super) {
    __extends(MarkerDiamondComponent, _super);
    function MarkerDiamondComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    MarkerDiamondComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { this.setAttributes(__assign({}, diamond)); };
    MarkerDiamondComponent.decorators = [
        { type: Component, args: [{ selector: "[ibm-graph-marker-diamond]", template: template }] }
    ];
    return MarkerDiamondComponent;
}(MarkerComponent));
var MarkerSquareComponent = /** @class */ (function (_super) {
    __extends(MarkerSquareComponent, _super);
    function MarkerSquareComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    MarkerSquareComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { this.setAttributes(__assign({}, square)); };
    MarkerSquareComponent.decorators = [
        { type: Component, args: [{ selector: "[ibm-graph-marker-square]", template: template }] }
    ];
    return MarkerSquareComponent;
}(MarkerComponent));
var MarkerTeeComponent = /** @class */ (function (_super) {
    __extends(MarkerTeeComponent, _super);
    function MarkerTeeComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    MarkerTeeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () { this.setAttributes(__assign({}, tee)); };
    MarkerTeeComponent.decorators = [
        { type: Component, args: [{ selector: "[ibm-graph-marker-tee]", template: template }] }
    ];
    return MarkerTeeComponent;
}(MarkerComponent));

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/marker/marker.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MarkerModule = /** @class */ (function () {
    function MarkerModule() {
    }
    MarkerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        MarkerComponent,
                        MarkerArrowLeftComponent,
                        MarkerArrowRightComponent,
                        MarkerShapeNodeComponent,
                        MarkerDiamondComponent,
                        MarkerSquareComponent,
                        MarkerTeeComponent
                    ],
                    exports: [
                        MarkerComponent,
                        MarkerArrowLeftComponent,
                        MarkerArrowRightComponent,
                        MarkerShapeNodeComponent,
                        MarkerDiamondComponent,
                        MarkerSquareComponent,
                        MarkerTeeComponent
                    ],
                    imports: [CommonModule]
                },] }
    ];
    return MarkerModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/shape-node/shape-node.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ShapeNodeComponent = /** @class */ (function () {
    function ShapeNodeComponent() {
        this.as = 'div';
        this.href = null;
        this.size = 48;
        this.shape = 'circle';
        this.position = 'fixed';
        this.bodyPosition = 'absolute';
        this.click = new EventEmitter();
        this.mouseEnter = new EventEmitter();
        this.mouseOver = new EventEmitter();
        this.mouseOut = new EventEmitter();
        this.mouseLeave = new EventEmitter();
        this.mouseMove = new EventEmitter();
        this.namespace = carbonPrefix + "--cc--shape-node";
        this.component = 'div';
    }
    /**
     * @return {?}
     */
    ShapeNodeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.href) {
            this.component = 'a';
        }
        else {
            this.component = this.as;
        }
    };
    ShapeNodeComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ibm-diagram-shape-node',
                    template: "\n\t\t<ng-container [ngSwitch]=\"component\">\n\t\t\t<xhtml:div\n\t\t\t\t*ngSwitchCase=\"'div'\"\n\t\t\t\t[ngClass]=\"[\n\t\t\t\t\tnamespace,\n\t\t\t\t\tstacked ? namespace + '--stacked' : '',\n\t\t\t\t\tshape ? namespace + '--' + shape : '',\n\t\t\t\t\tnamespace + '--' + component\n\t\t\t\t]\"\n\t\t\t\t[ngStyle]=\"{\n\t\t\t\t\t'height.px': size,\n\t\t\t\t\t'width.px': size,\n\t\t\t\t\tposition: position\n\t\t\t\t}\"\n\t\t\t\t(mouseenter)=\"mouseEnter.emit($event)\"\n\t\t\t\t(mouseover)=\"mouseOver.emit($event)\"\n\t\t\t\t(mouseout)=\"mouseOut.emit($event)\"\n\t\t\t\t(mouseleave)=\"mouseLeave.emit($event)\"\n\t\t\t\t(mousemove)=\"mouseMove.emit($event)\"\n\t\t\t\ttabindex=\"0\"\n\t\t\t>\n\t\t\t\t<ng-container *ngTemplateOutlet=\"nodeTemplate\"></ng-container>\n\t\t\t</xhtml:div>\n\n\t\t\t<xhtml:button\n\t\t\t\t*ngSwitchCase=\"'button'\"\n\t\t\t\t[ngClass]=\"[\n\t\t\t\t\tnamespace,\n\t\t\t\t\tstacked ? namespace + '--stacked' : '',\n\t\t\t\t\tshape ? namespace + '--' + shape : '',\n\t\t\t\t\tnamespace + '--' + component\n\t\t\t\t]\"\n\t\t\t\t[ngStyle]=\"{\n\t\t\t\t\t'height.px': size,\n\t\t\t\t\t'width.px': size,\n\t\t\t\t\tposition: position\n\t\t\t\t}\"\n\t\t\t\t(click)=\"click.emit($event)\"\n\t\t\t\t(mouseenter)=\"mouseEnter.emit($event)\"\n\t\t\t\t(mouseover)=\"mouseOver.emit($event)\"\n\t\t\t\t(mouseout)=\"mouseOut.emit($event)\"\n\t\t\t\t(mouseleave)=\"mouseLeave.emit($event)\"\n\t\t\t\t(mousemove)=\"mouseMove.emit($event)\"\n\t\t\t\ttabindex=\"0\"\n\t\t\t>\n\t\t\t\t<ng-container *ngTemplateOutlet=\"nodeTemplate\"></ng-container>\n\t\t\t</xhtml:button>\n\n\t\t\t<xhtml:a\n\t\t\t\t*ngSwitchCase=\"'a'\"\n\t\t\t\t[ngClass]=\"[\n\t\t\t\t\tnamespace,\n\t\t\t\t\tstacked ? namespace + '--stacked' : '',\n\t\t\t\t\tshape ? namespace + '--' + shape : '',\n\t\t\t\t\tnamespace + '--' + component\n\t\t\t\t]\"\n\t\t\t\t[attr.href]=\"href\"\n\t\t\t\t[ngStyle]=\"{\n\t\t\t\t\t'height.px': size,\n\t\t\t\t\t'width.px': size,\n\t\t\t\t\tposition: position\n\t\t\t\t}\"\n\t\t\t\t(mouseenter)=\"mouseEnter.emit($event)\"\n\t\t\t\t(mouseover)=\"mouseOver.emit($event)\"\n\t\t\t\t(mouseout)=\"mouseOut.emit($event)\"\n\t\t\t\t(mouseleave)=\"mouseLeave.emit($event)\"\n\t\t\t\t(mousemove)=\"mouseMove.emit($event)\"\n\t\t\t\ttabindex=\"0\"\n\t\t\t>\n\t\t\t\t<ng-container *ngTemplateOutlet=\"nodeTemplate\"></ng-container>\n\t\t\t</xhtml:a>\n\t\t</ng-container>\n\n\t\t<ng-template #nodeTemplate>\n\t\t\t<div *ngIf=\"renderIcon\" attr.class=\"{{ namespace + '__icon' }}\">\n\t\t\t\t<ng-container *ngTemplateOutlet=\"renderIcon\"></ng-container>\n\t\t\t</div>\n\t\t\t<div\n\t\t\t\tattr.class=\"{{ namespace + '__body' }}\"\n\t\t\t\t[ngStyle]=\"{ position: bodyPosition }\"\n\t\t\t>\n\t\t\t\t<div attr.class=\"{{ namespace + '__title' }}\">{{ title }}</div>\n\t\t\t\t<div attr.class=\"{{ namespace + '__subtitle' }}\">\n\t\t\t\t\t{{ subtitle }}\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</ng-template>\n\t"
                }] }
    ];
    ShapeNodeComponent.propDecorators = {
        as: [{ type: Input }],
        href: [{ type: Input }],
        renderIcon: [{ type: Input }],
        size: [{ type: Input }],
        stacked: [{ type: Input }],
        shape: [{ type: Input }],
        subtitle: [{ type: Input }],
        title: [{ type: Input }],
        position: [{ type: Input }],
        bodyPosition: [{ type: Input }],
        click: [{ type: Output }],
        mouseEnter: [{ type: Output }],
        mouseOver: [{ type: Output }],
        mouseOut: [{ type: Output }],
        mouseLeave: [{ type: Output }],
        mouseMove: [{ type: Output }]
    };
    return ShapeNodeComponent;
}());
if (false) {
    /** @type {?} */
    ShapeNodeComponent.prototype.as;
    /** @type {?} */
    ShapeNodeComponent.prototype.href;
    /** @type {?} */
    ShapeNodeComponent.prototype.renderIcon;
    /** @type {?} */
    ShapeNodeComponent.prototype.size;
    /** @type {?} */
    ShapeNodeComponent.prototype.stacked;
    /** @type {?} */
    ShapeNodeComponent.prototype.shape;
    /** @type {?} */
    ShapeNodeComponent.prototype.subtitle;
    /** @type {?} */
    ShapeNodeComponent.prototype.title;
    /** @type {?} */
    ShapeNodeComponent.prototype.position;
    /** @type {?} */
    ShapeNodeComponent.prototype.bodyPosition;
    /** @type {?} */
    ShapeNodeComponent.prototype.click;
    /** @type {?} */
    ShapeNodeComponent.prototype.mouseEnter;
    /** @type {?} */
    ShapeNodeComponent.prototype.mouseOver;
    /** @type {?} */
    ShapeNodeComponent.prototype.mouseOut;
    /** @type {?} */
    ShapeNodeComponent.prototype.mouseLeave;
    /** @type {?} */
    ShapeNodeComponent.prototype.mouseMove;
    /** @type {?} */
    ShapeNodeComponent.prototype.namespace;
    /** @type {?} */
    ShapeNodeComponent.prototype.component;
}

/**
 * @fileoverview added by tsickle
 * Generated from: diagrams/shape-node/shape-node.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ShapeNodeModule = /** @class */ (function () {
    function ShapeNodeModule() {
    }
    ShapeNodeModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ShapeNodeComponent],
                    exports: [ShapeNodeComponent],
                    imports: [CommonModule]
                },] }
    ];
    return ShapeNodeModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: carbon-charts-angular.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AlluvialChartComponent, AreaChartComponent, BaseChart, BoxplotChartComponent, BubbleChartComponent, BulletChartComponent, CardNodeColumnComponent, CardNodeComponent, CardNodeLabelComponent, CardNodeModule, CardNodeSubtitleComponent, CardNodeTitleComponent, ChartsModule, CirclePackChartComponent, ComboChartComponent, DonutChartComponent, EdgeComponent, EdgeModule, GaugeChartComponent, GroupedBarChartComponent, HeatmapChartComponent, HistogramChartComponent, LineChartComponent, LollipopChartComponent, MarkerArrowLeftComponent, MarkerArrowRightComponent, MarkerComponent, MarkerDiamondComponent, MarkerModule, MarkerShapeNodeComponent, MarkerSquareComponent, MarkerTeeComponent, MeterChartComponent, PieChartComponent, RadarChartComponent, ScatterChartComponent, ShapeNodeComponent, ShapeNodeModule, SimpleBarChartComponent, StackedAreaChartComponent, StackedBarChartComponent, TreeChartComponent, TreemapChartComponent, WordCloudChartComponent, EXPERIMENTAL_ChoroplethChartComponent as ɵa };
//# sourceMappingURL=carbon-charts-angular.js.map
